=== debian/changelog ===
bctoolbox (0.6.0-2build1) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:42:26 +0000

bctoolbox (0.6.0-2) unstable; urgency=medium

  * Team upload.
  * Use debhelper v11
  * Set Multi-Arch: same for libbctoolbox1
  * Update Vcs-URLs to salsa.d.o
  * Update d/copyright
  * Add new patch to fix FTBFS with new mbedtls-2.7.0.
    Thanks to James Cowgill <jcowgill@debian.org> (Closes: #890417)
  * Update Standards-Version to 4.1.3, no changes needed
  * Update d/watch to github location
  * Remove d/README.source, no longer applies

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 14 Feb 2018 20:33:51 +0100

bctoolbox (0.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    - Bump static deps in libbctoolbox1.shlibs

 -- Bernhard Schmidt <berni@debian.org>  Sun, 15 Oct 2017 23:05:54 +0200

bctoolbox (0.5.1-1) unstable; urgency=medium

  [ Daniel Gnoutcheff ]
  * Initial release (Closes: #849491)

 -- Bernhard Schmidt <berni@debian.org>  Wed, 05 Jul 2017 19:52:34 +0200
