=== debian/control ===
Source: bctoolbox
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Daniel Gnoutcheff <daniel@gnoutcheff.name>,
Build-Depends: cmake (>= 2.8.12),
               debhelper (>= 11),
               libmbedtls-dev,
Standards-Version: 4.1.3
Section: libs
Homepage: http://linphone.org/releases/sources/bctoolbox/
Vcs-Git: https://salsa.debian.org/pkg-voip-team/bctoolbox.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/bctoolbox

Package: libbctoolbox-dev
Section: libdevel
Architecture: any
Depends: libbctoolbox1 (= ${binary:Version}),
         ${misc:Depends},
Description: Helper code for software by Belledonne Communications (development headers)
 The package provides a C/C++ utility library used by Linphone and other
 software by Belledonne Communications. The library offers platform independent
 implementations of cryptographic functions, exception handling, logging
 modules, file access, unit tests and data structures like lists and maps.
 .
 The package is probably not useful outside the Belledonne Communications suite
 of libraries and programs.
 .
 This package contains the development headers.

Package: libbctoolbox1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: Helper library for software by Belledonne Communications (shared library)
 The package provides a C/C++ utility library used by Linphone and other
 software by Belledonne Communications. The library offers platform independent
 implementations of cryptographic functions, exception handling, logging
 modules, file access, unit tests and data structures like lists and maps.
 .
 The package is probably not useful outside the Belledonne Communications suite
 of libraries and programs.
 .
 This package contains the shared library.
