=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7)
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

# As of version 0.4.0, upstream recommends CMake for configuration.
# Requires CUnit 3.x by default, which is not available in Debian as of Dec
# 2016.  Disable tests for now to avoid build configure failures.
#
# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON -DENABLE_TESTS_COMPONENT=OFF
